/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.40 Revision 1.139
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.40 2009/06/27 18:55:02 yngwin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.139 2012/11/12 09:28:53 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit base eutils multilib toolchain-funcs flag-o-matic versionator
15
16IUSE="${IUSE} debug pch"
17RDEPEND="
18 !<x11-libs/qt-assistant-${PV}
19 !>x11-libs/qt-assistant-${PV}-r9999
20 !<x11-libs/qt-core-${PV}
21 !>x11-libs/qt-core-${PV}-r9999
22 !<x11-libs/qt-dbus-${PV}
23 !>x11-libs/qt-dbus-${PV}-r9999
24 !<x11-libs/qt-demo-${PV}
25 !>x11-libs/qt-demo-${PV}-r9999
26 !<x11-libs/qt-gui-${PV}
27 !>x11-libs/qt-gui-${PV}-r9999
28 !<x11-libs/qt-opengl-${PV}
29 !>x11-libs/qt-opengl-${PV}-r9999
30 !<x11-libs/qt-phonon-${PV}
31 !>x11-libs/qt-phonon-${PV}-r9999
32 !<x11-libs/qt-qt3support-${PV}
33 !>x11-libs/qt-qt3support-${PV}-r9999
34 !<x11-libs/qt-script-${PV}
35 !>x11-libs/qt-script-${PV}-r9999
36 !<x11-libs/qt-sql-${PV}
37 !>x11-libs/qt-sql-${PV}-r9999
38 !<x11-libs/qt-svg-${PV}
39 !>x11-libs/qt-svg-${PV}-r9999
40 !<x11-libs/qt-test-${PV}
41 !>x11-libs/qt-test-${PV}-r9999
42 !<x11-libs/qt-webkit-${PV}
43 !>x11-libs/qt-webkit-${PV}-r9999
44 !<x11-libs/qt-xmlpatterns-${PV}
45 !>x11-libs/qt-xmlpatterns-${PV}-r9999
46"
47case "${PV}" in 12case ${EAPI} in
48 4.?.?_rc*) 13 3|4|5) : ;;
49 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
50 MY_PV="${PV/_rc/-rc}" 29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
51 ;; 37 ;;
52 *) 38 release)
53 SRCTYPE="${SRCTYPE:-opensource-src}" 39 if version_is_at_least 4.8.1; then
54 MY_PV="${PV}" 40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
55 ;; 44 ;;
56esac 45esac
57MY_P=qt-x11-${SRCTYPE}-${MY_PV} 46
47IUSE="aqua debug pch"
48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
49if version_is_at_least 4.8; then
50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
51 version_is_at_least 4.8.3 || IUSE+=" qpa"
52fi
53
54DEPEND="virtual/pkgconfig"
55if [[ ${QT4_BUILD_TYPE} == live ]]; then
56 DEPEND+=" dev-lang/perl"
57fi
58
59RDEPEND="
60 !<x11-libs/qt-assistant-${PV}:4
61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
64 !<x11-libs/qt-core-${PV}:4
65 !>x11-libs/qt-core-${PV}-r9999:4
66 !<x11-libs/qt-dbus-${PV}:4
67 !>x11-libs/qt-dbus-${PV}-r9999:4
68 !<x11-libs/qt-declarative-${PV}:4
69 !>x11-libs/qt-declarative-${PV}-r9999:4
70 !<x11-libs/qt-demo-${PV}:4
71 !>x11-libs/qt-demo-${PV}-r9999:4
72 !<x11-libs/qt-gui-${PV}:4
73 !>x11-libs/qt-gui-${PV}-r9999:4
74 !<x11-libs/qt-multimedia-${PV}:4
75 !>x11-libs/qt-multimedia-${PV}-r9999:4
76 !<x11-libs/qt-opengl-${PV}:4
77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
80 !<x11-libs/qt-phonon-${PV}:4
81 !>x11-libs/qt-phonon-${PV}-r9999:4
82 !<x11-libs/qt-qt3support-${PV}:4
83 !>x11-libs/qt-qt3support-${PV}-r9999:4
84 !<x11-libs/qt-script-${PV}:4
85 !>x11-libs/qt-script-${PV}-r9999:4
86 !<x11-libs/qt-sql-${PV}:4
87 !>x11-libs/qt-sql-${PV}-r9999:4
88 !<x11-libs/qt-svg-${PV}:4
89 !>x11-libs/qt-svg-${PV}-r9999:4
90 !<x11-libs/qt-test-${PV}:4
91 !>x11-libs/qt-test-${PV}-r9999:4
92 !<x11-libs/qt-webkit-${PV}:4
93 !>x11-libs/qt-webkit-${PV}-r9999:4
94 !<x11-libs/qt-xmlpatterns-${PV}:4
95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
96"
97
58S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
59 99
60HOMEPAGE="http://www.qtsoftware.com/"
61SRC_URI="http://get.qtsoftware.com/qt/source/${MY_P}.tar.bz2"
62
63case "${PV}" in
64 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
65 *) ;;
66esac
67
68if version_is_at_least 4.5 ${PV} ; then
69 LICENSE="|| ( LGPL-2.1 GPL-3 )"
70fi
71
72# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
73# @DESCRIPTION: 101# @DESCRIPTION:
74# Sets up installation directories, PLATFORM, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
75qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
76 # EAPI=2 ebuilds set use-deps, others need this: 104 # Protect users by not allowing downgrades between releases.
77 if [[ $EAPI != 2 ]]; then 105 # Downgrading revisions within the same release should be allowed.
78 # Make sure debug setting corresponds with qt-core (bug 258512) 106 if has_version ">${CATEGORY}/${P}-r9999:4"; then
79 if [[ $PN != "qt-core" ]]; then 107 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
80 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 108 eerror " *** Sanity check to keep you from breaking your system ***"
81 ~x11-libs/qt-core-${PV} debug" 109 eerror "Downgrading Qt is completely unsupported and will break your system!"
82 fi 110 die "aborting to save your system"
83 111 else
84 # Check USE requirements 112 ewarn "Downgrading Qt is completely unsupported and will break your system!"
85 qt4-build_check_use
86 fi 113 fi
87 # Set up installation directories 114 fi
88 QTBASEDIR=/usr/$(get_libdir)/qt4
89 QTPREFIXDIR=/usr
90 QTBINDIR=/usr/bin
91 QTLIBDIR=/usr/$(get_libdir)/qt4
92 QTPCDIR=/usr/$(get_libdir)/pkgconfig
93 QTDATADIR=/usr/share/qt4
94 QTDOCDIR=/usr/share/doc/qt-${PV}
95 QTHEADERDIR=/usr/include/qt4
96 QTPLUGINDIR=${QTLIBDIR}/plugins
97 QTSYSCONFDIR=/etc/qt4
98 QTTRANSDIR=${QTDATADIR}/translations
99 QTEXAMPLESDIR=${QTDATADIR}/examples
100 QTDEMOSDIR=${QTDATADIR}/demos
101 115
102 PLATFORM=$(qt_mkspecs_dir)
103
104 PATH="${S}/bin:${PATH}" 116 PATH="${S}/bin${PATH:+:}${PATH}"
117 if [[ ${CHOST} != *-darwin* ]]; then
105 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 118 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
106 119 else
107 if ! version_is_at_least 4.1 $(gcc-version) ; then 120 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
108 ewarn "Using a GCC version lower than 4.1 is not supported!" 121 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
109 echo 122 # platform detection. Note: needs to come before any directories to
110 ebeep 3 123 # avoid extract failure.
124 [[ ${CHOST} == *-apple-darwin* ]] && \
125 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
126 ${QT4_EXTRACT_DIRECTORIES}"
111 fi 127 fi
112} 128}
129
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DEFAULT_UNSET
132# @DESCRIPTION:
133# Space-separated list including the directories that will be extracted from
134# Qt tarball.
113 135
114# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 136# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
137# @DEFAULT_UNSET
115# @DESCRIPTION: 138# @DESCRIPTION:
116# Arguments for build_target_directories. Takes the directories, in which the 139# Arguments for build_target_directories. Takes the directories in which the
117# code should be compiled. This is a space-separated list 140# code should be compiled. This is a space-separated list.
118
119# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
120# @DESCRIPTION:
121# Space separated list including the directories that will be extracted from Qt
122# tarball
123 141
124# @FUNCTION: qt4-build_src_unpack 142# @FUNCTION: qt4-build_src_unpack
125# @DESCRIPTION: 143# @DESCRIPTION:
126# Unpacks the sources 144# Unpacks the sources.
127qt4-build_src_unpack() { 145qt4-build_src_unpack() {
128 local target targets licenses 146 setqtenv
147
129 if version_is_at_least 4.5 ${PV} ; then 148 if ! version_is_at_least 4.1 $(gcc-version); then
130 licenses="LICENSE.GPL3 LICENSE.LGPL" 149 ewarn "Using a GCC version lower than 4.1 is not supported."
131 else 150 fi
132 licenses="LICENSE.GPL2 LICENSE.GPL3" 151
152 if [[ ${PN} == qt-webkit ]]; then
153 eshopts_push -s extglob
154 if is-flagq '-g?(gdb)?([1-9])'; then
155 echo
156 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
157 ewarn "You may experience really long compilation times and/or increased memory usage."
158 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
159 ewarn "For more info check out https://bugs.gentoo.org/307861"
160 echo
133 fi 161 fi
134 for target in configure ${licenses} projects.pro \ 162 eshopts_pop
163 fi
164
165 case ${QT4_BUILD_TYPE} in
166 live)
167 git-2_src_unpack
168 ;;
169 release)
170 local tarball="${MY_P}.tar.gz" target= targets=
171 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
135 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 172 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
136 ${QT4_EXTRACT_DIRECTORIES}; do 173 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
174 do
137 targets="${targets} ${MY_P}/${target}" 175 targets+="${MY_P}/${target} "
138 done 176 done
139 177
140 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 178 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
141 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 179 tar -xzf "${DISTDIR}/${tarball}" ${targets}
142 180 eend $? || die "failed to unpack"
143 case "${PV}" in
144 4.4.?)
145 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
146 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
147 ;; 181 ;;
148 esac 182 esac
149
150 # Be backwards compatible for now
151 if [[ $EAPI != 2 ]]; then
152 qt4-build_src_prepare
153 fi
154} 183}
155 184
156# @ECLASS-VARIABLE: PATCHES 185# @ECLASS-VARIABLE: PATCHES
186# @DEFAULT_UNSET
157# @DESCRIPTION: 187# @DESCRIPTION:
158# In case you have patches to apply, specify them in PATCHES variable. Make sure 188# PATCHES array variable containing all various patches to be applied.
159# to specify the full path. This variable is necessary for src_prepare phase. 189# This variable is expected to be defined in global scope of ebuild.
160# example: 190# Make sure to specify the full path. This variable is utilised in
161# PATCHES="${FILESDIR}"/mypatch.patch 191# src_prepare() phase.
162# ${FILESDIR}"/mypatch2.patch"
163# 192#
193# @CODE
194# PATCHES=( "${FILESDIR}/mypatch.patch"
195# "${FILESDIR}/patches_folder/" )
196# @CODE
164 197
165# @FUNCTION: qt4-build_src_prepare 198# @FUNCTION: qt4-build_src_prepare
166# @DESCRIPTION: 199# @DESCRIPTION:
167# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 200# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
168# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 201# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
169qt4-build_src_prepare() { 202qt4-build_src_prepare() {
170 cd "${S}" 203 setqtenv
204
205 if [[ ${QT4_BUILD_TYPE} == live ]]; then
206 QTDIR="." ./bin/syncqt || die "syncqt failed"
207 fi
208
209 # avoid X11 dependency in non-gui packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 if use aqua; then
214 # provide a proper macx-g++-64
215 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
216
217 sed -e '/^CONFIG/s:app_bundle::' \
218 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
219 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
220 fi
171 221
172 if [[ ${PN} != qt-core ]]; then 222 if [[ ${PN} != qt-core ]]; then
173 skip_qmake_build_patch 223 skip_qmake_build
174 skip_project_generation_patch 224 skip_project_generation
175 symlink_binaries_to_buildtree 225 symlink_binaries_to_buildtree
176 fi 226 fi
177 227
228 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
229 # qmake bus errors with -O2 or -O3 but -O1 works
230 # Bug 373061
231 replace-flags -O[23] -O1
232 fi
233
178 # Bug 178652 234 # Bug 178652
179 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 235 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
180 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 236 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
181 append-flags -fno-gcse 237 append-flags -fno-gcse
182 fi 238 fi
183 239
240 if use_if_iuse c++0x; then
241 append-cxxflags -std=c++0x
242 fi
243
184 # Unsupported old gcc versions - hardened needs this :( 244 # Unsupported old gcc versions - hardened needs this :(
185 if [[ $(gcc-major-version) -lt "4" ]] ; then 245 if [[ $(gcc-major-version) -lt 4 ]]; then
186 ewarn "Appending -fno-stack-protector to CXXFLAGS" 246 ewarn "Appending -fno-stack-protector to CXXFLAGS"
187 append-cxxflags -fno-stack-protector 247 append-cxxflags -fno-stack-protector
188 # Bug 253127 248 # Bug 253127
189 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 249 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
190 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 250 -i mkspecs/common/g++.conf || die
251 fi
252
253 # Bug 261632
254 if use ppc64; then
255 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
256 append-flags -mminimal-toc
257 fi
258
259 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
260 sed -e "/^SYSTEM_VARIABLES=/i \
261 CC='$(tc-getCC)'\n\
262 CXX='$(tc-getCXX)'\n\
263 CFLAGS='${CFLAGS}'\n\
264 CXXFLAGS='${CXXFLAGS}'\n\
265 LDFLAGS='${LDFLAGS}'\n\
266 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
267 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
268 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
269 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
270 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
271 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
272 -i configure \
273 || die "sed SYSTEM_VARIABLES failed"
274
275 # Respect CC, CXX, LINK and *FLAGS in config.tests
276 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
277 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
278 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
279 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
280 || die "sed config.tests failed"
281
282 if ! version_is_at_least 4.8; then
283 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
284 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
191 fi 285 fi
192 286
193 # Bug 172219 287 # Bug 172219
288 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
289
290 if [[ ${CHOST} == *-darwin* ]]; then
291 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
292 # crippled (by design) :/
293 local mac_gpp_conf=
294 if [[ -f mkspecs/common/mac-g++.conf ]]; then
295 # qt < 4.8 has mac-g++.conf
296 mac_gpp_conf="mkspecs/common/mac-g++.conf"
297 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
298 # qt >= 4.8 has g++-macx.conf
299 mac_gpp_conf="mkspecs/common/g++-macx.conf"
300 else
301 die "no known conf file for mac found"
302 fi
303 sed \
194 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 304 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
195 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 305 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
196 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 306 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
197 -e "s:X11R6/::" \ 307 -e "s:-arch\s\w*::g" \
198 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 308 -i ${mac_gpp_conf} \
309 || die "sed ${mac_gpp_conf} failed"
199 310
200 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 311 # Fix configure's -arch settings that appear in qmake/Makefile and also
201 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 312 # fix arch handling (automagically duplicates our -arch arg and breaks
202 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 313 # pch). Additionally disable Xarch support.
203 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 314 local mac_gcc_confs="${mac_gpp_conf}"
315 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
316 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
317 fi
318 sed \
319 -e "s:-arch i386::" \
320 -e "s:-arch ppc::" \
321 -e "s:-arch x86_64::" \
322 -e "s:-arch ppc64::" \
323 -e "s:-arch \$i::" \
324 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
325 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
326 -e "s:-Xarch_x86_64::g" \
327 -e "s:-Xarch_ppc64::g" \
328 -i configure ${mac_gcc_confs} \
329 || die "sed -arch/-Xarch failed"
204 330
205 base_src_prepare 331 # On Snow Leopard don't fall back to 10.5 deployment target.
332 if [[ ${CHOST} == *-apple-darwin10 ]]; then
333 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
334 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
335 -i configure ${mac_gpp_conf} \
336 || die "sed deployment target failed"
337 fi
338 fi
339
340 # this one is needed for all systems with a separate -liconv, apart from
341 # Darwin, for which the sources already cater for -liconv
342 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
343 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
344 -i config.tests/unix/iconv/iconv.pro \
345 || die "sed iconv.pro failed"
346 fi
347
348 # we need some patches for Solaris
349 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
350 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
351 # use GCC over SunStudio
352 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
353 # do not flirt with non-Prefix stuff, we're quite possessive
354 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
355 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
356
357 # apply patches
358 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
359 epatch_user
206} 360}
207 361
208# @FUNCTION: qt4-build_src_configure 362# @FUNCTION: qt4-build_src_configure
209# @DESCRIPTION: 363# @DESCRIPTION:
210# Default configure phase 364# Default configure phase
211qt4-build_src_configure() { 365qt4-build_src_configure() {
366 setqtenv
212 367
213 myconf="$(standard_configure_options) ${myconf}"
214
215 echo ./configure ${myconf}
216 ./configure ${myconf} || die "./configure failed"
217}
218
219# @FUNCTION: qt4-build_src_compile
220# @DESCRIPTION: Actual compile phase
221qt4-build_src_compile() {
222 # Be backwards compatible for now
223 if [[ $EAPI != 2 ]]; then
224 qt4-build_src_configure
225 fi
226
227 build_directories "${QT4_TARGET_DIRECTORIES}"
228}
229
230# @FUNCTION: qt4-build_src_install
231# @DESCRIPTION:
232# Perform the actual installation including some library fixes.
233qt4-build_src_install() {
234 install_directories "${QT4_TARGET_DIRECTORIES}"
235 install_qconfigs
236 fix_library_files
237}
238
239# @FUNCTION: standard_configure_options
240# @DESCRIPTION:
241# Sets up some standard configure options, like libdir (if necessary), whether
242# debug info is wanted or not.
243standard_configure_options() {
244 local myconf="" 368 local conf="
245 369 -prefix ${QTPREFIXDIR}
246 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 370 -bindir ${QTBINDIR}
247 371 -libdir ${QTLIBDIR}
248 # Disable visibility explicitly if gcc version isn't 4 372 -docdir ${QTDOCDIR}
249 if [[ "$(gcc-major-version)" -lt "4" ]]; then 373 -headerdir ${QTHEADERDIR}
250 myconf="${myconf} -no-reduce-exports" 374 -plugindir ${QTPLUGINDIR}
251 fi 375 -importdir ${QTIMPORTDIR}
252 376 -datadir ${QTDATADIR}
253 # precompiled headers doesn't work on hardened, where the flag is masked. 377 -translationdir ${QTTRANSDIR}
254 if use pch; then 378 -sysconfdir ${QTSYSCONFDIR}
255 myconf="${myconf} -pch" 379 -examplesdir ${QTEXAMPLESDIR}
256 else 380 -demosdir ${QTDEMOSDIR}
257 myconf="${myconf} -no-pch" 381 -opensource -confirm-license
258 fi 382 -shared -fast -largefile -stl -verbose
259 383 -nomake examples -nomake demos"
260 if use debug; then
261 myconf="${myconf} -debug -no-separate-debug-info"
262 else
263 myconf="${myconf} -release -no-separate-debug-info"
264 fi
265 384
266 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 385 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
267 # $(tc-arch). Therefore we convert it to supported values. 386 # $(tc-arch). Therefore we convert it to supported values.
268 case "$(tc-arch)" in 387 case "$(tc-arch)" in
269 amd64) myconf="${myconf} -arch x86_64" ;; 388 amd64|x64-*) conf+=" -arch x86_64" ;;
389 ppc-macos) conf+=" -arch ppc" ;;
270 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;;
271 x86|x86-*) myconf="${myconf} -arch i386" ;; 393 x86|x86-*) conf+=" -arch i386" ;;
272 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
273 hppa|sh) myconf="${myconf} -arch generic" ;; 395 hppa|sh) conf+=" -arch generic" ;;
274 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
275 esac 397 esac
276 398
277 myconf="${myconf} -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license -no-rpath 399 conf+=" -platform $(qt_mkspecs_dir)"
278 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
279 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
280 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
281 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
282 -demosdir ${QTDEMOSDIR} -silent -fast
283 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
284 -reduce-relocations -nomake examples -nomake demos"
285 400
286 # Make eclass 4.5.{1,2} ready 401 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
287 case "${MY_PV}" in
288 4.5.1 | 4.5.2)
289 myconf="${myconf} -opensource"
290 ;;
291 esac
292 402
403 # debug/release
404 if use debug; then
405 conf+=" -debug"
406 else
407 conf+=" -release"
408 fi
409 conf+=" -no-separate-debug-info"
410
411 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413
414 # disable rpath on Qt >= 4.8 (bug 380415)
415 # but leave it enabled on prefix (bug 417169)
416 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
417
418 # precompiled headers don't work on hardened, where the flag is masked
419 conf+=" $(qt_use pch)"
420
421 # -reduce-relocations
422 # This flag seems to introduce major breakage to applications,
423 # mostly to be seen as a core dump with the message "QPixmap: Must
424 # construct a QApplication before a QPaintDevice" on Solaris.
425 # -- Daniel Vergien
426 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
427
428 # this one is needed for all systems with a separate -liconv, apart from
429 # Darwin, for which the sources already cater for -liconv
430 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
431 conf+=" -liconv"
432 fi
433
434 if use_if_iuse glib; then
435 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
436 # avoid the -pthread argument
437 conf+=" ${glibflags//-pthread}"
438 unset glibflags
439 fi
440
441 if use_if_iuse qpa; then
442 echo
443 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
444 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
445 ewarn "disable it before reporting any bugs related to this useflag."
446 echo
447 conf+=" -qpa"
448 fi
449
450 if use aqua; then
451 # On (snow) leopard use the new (frameworked) cocoa code.
452 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
453 conf+=" -cocoa -framework"
454 # We need the source's headers, not the installed ones.
455 conf+=" -I${S}/include"
456 # Add hint for the framework location.
457 conf+=" -F${QTLIBDIR}"
458
459 # We are crazy and build cocoa + qt3support :-)
460 if use qt3support; then
461 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
462 -i configure || die
463 fi
464 else
465 conf+=" -no-framework"
466 fi
467 else
468 # freetype2 include dir is non-standard, thus pass it to configure
469 conf+=" $(pkg-config --cflags-only-I freetype2)"
470 fi
471
293 echo "${myconf}" 472 conf+=" ${myconf}"
473 myconf=
474
475 echo ./configure ${conf}
476 ./configure ${conf} || die "./configure failed"
477
478 prepare_directories ${QT4_TARGET_DIRECTORIES}
479}
480
481# @FUNCTION: qt4-build_src_compile
482# @DESCRIPTION:
483# Actual compile phase
484qt4-build_src_compile() {
485 setqtenv
486
487 build_directories ${QT4_TARGET_DIRECTORIES}
488}
489
490# @FUNCTION: qt4-build_src_test
491# @DESCRIPTION:
492# Runs tests only in target directories.
493qt4-build_src_test() {
494 # QtMultimedia does not have any test suite (bug #332299)
495 [[ ${PN} == qt-multimedia ]] && return
496
497 for dir in ${QT4_TARGET_DIRECTORIES}; do
498 emake -j1 check -C ${dir}
499 done
500}
501
502# @FUNCTION: fix_includes
503# @DESCRIPTION:
504# For MacOS X we need to add some symlinks when frameworks are
505# being used, to avoid complications with some more or less stupid packages.
506fix_includes() {
507 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
508 local frw dest f h rdir
509 # Some packages tend to include <Qt/...>
510 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
511
512 # Fake normal headers when frameworks are installed... eases life later
513 # on, make sure we use relative links though, as some ebuilds assume
514 # these dirs exist in src_install to add additional files
515 f=${QTHEADERDIR}
516 h=${QTLIBDIR}
517 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
518 f=${f#*/}
519 h=${h#*/}
520 done
521 rdir=${h}
522 f="../"
523 while [[ ${h} == */* ]] ; do
524 f="${f}../"
525 h=${h#*/}
526 done
527 rdir="${f}${rdir}"
528
529 for frw in "${D}${QTLIBDIR}"/*.framework; do
530 [[ -e "${frw}"/Headers ]] || continue
531 f=$(basename ${frw})
532 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
533 dosym "${rdir}"/${f}/Headers "${dest}"
534
535 # Link normal headers as well.
536 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
537 h=$(basename ${hdr})
538 dosym "../${rdir}"/${f}/Headers/${h} \
539 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
540 done
541 done
542 fi
543}
544
545# @FUNCTION: qt4-build_src_install
546# @DESCRIPTION:
547# Perform the actual installation including some library fixes.
548qt4-build_src_install() {
549 setqtenv
550
551 install_directories ${QT4_TARGET_DIRECTORIES}
552 install_qconfigs
553 fix_library_files
554 fix_includes
555
556 # remove .la files since we are building only shared libraries
557 prune_libtool_files
558}
559
560# @FUNCTION: setqtenv
561# @INTERNAL
562setqtenv() {
563 # Set up installation directories
564 QTPREFIXDIR=${EPREFIX}/usr
565 QTBINDIR=${QTPREFIXDIR}/bin
566 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
567 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
568 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
569 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
570 QTPLUGINDIR=${QTLIBDIR}/plugins
571 QTIMPORTDIR=${QTLIBDIR}/imports
572 QTDATADIR=${QTPREFIXDIR}/share/qt4
573 QTTRANSDIR=${QTDATADIR}/translations
574 QTSYSCONFDIR=${EPREFIX}/etc/qt4
575 QTEXAMPLESDIR=${QTDATADIR}/examples
576 QTDEMOSDIR=${QTDATADIR}/demos
577 QMAKE_LIBDIR_QT=${QTLIBDIR}
578
579 PLATFORM=$(qt_mkspecs_dir)
580 unset QMAKESPEC
581
582 export XDG_CONFIG_HOME="${T}"
583}
584
585# @FUNCTION: prepare_directories
586# @USAGE: < directories >
587# @INTERNAL
588# @DESCRIPTION:
589# Generates Makefiles for the given list of directories.
590prepare_directories() {
591 # avoid running over the maximum argument number, bug #299810
592 {
593 echo "${S}"/mkspecs/common/*.conf
594 find "${S}" -name '*.pr[io]'
595 } | xargs sed -i \
596 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
597 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
598 || die
599
600 for x in "$@"; do
601 pushd "${S}"/${x} >/dev/null || die
602 einfo "Running qmake in: ${x}"
603 "${S}"/bin/qmake \
604 "LIBS+=-L${QTLIBDIR}" \
605 "CONFIG+=nostrip" \
606 || die "qmake failed"
607 popd >/dev/null || die
608 done
294} 609}
295 610
296# @FUNCTION: build_directories 611# @FUNCTION: build_directories
297# @USAGE: < directories > 612# @USAGE: < directories >
613# @INTERNAL
298# @DESCRIPTION: 614# @DESCRIPTION:
299# Compiles the code in $QT4_TARGET_DIRECTORIES 615# Compiles the code in the given list of directories.
300build_directories() { 616build_directories() {
301 local dirs="$@"
302 for x in ${dirs}; do 617 for x in "$@"; do
303 cd "${S}"/${x} 618 pushd "${S}"/${x} >/dev/null || die
304 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 619 emake \
620 AR="$(tc-getAR) cqs" \
621 CC="$(tc-getCC)" \
622 CXX="$(tc-getCXX)" \
623 LINK="$(tc-getCXX)" \
624 RANLIB=":" \
625 STRIP=":" \
305 emake || die "emake failed" 626 || die "emake failed"
627 popd >/dev/null || die
306 done 628 done
307} 629}
308 630
309# @FUNCTION: install_directories 631# @FUNCTION: install_directories
310# @USAGE: < directories > 632# @USAGE: < directories >
633# @INTERNAL
311# @DESCRIPTION: 634# @DESCRIPTION:
312# run emake install in the given directories, which are separated by spaces 635# Runs emake install in the given directories, which are separated by spaces.
313install_directories() { 636install_directories() {
314 local dirs="$@"
315 for x in ${dirs}; do 637 for x in "$@"; do
316 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 638 pushd "${S}"/${x} >/dev/null || die
317 emake INSTALL_ROOT="${D}" install || die "emake install failed" 639 emake INSTALL_ROOT="${D}" install || die "emake install failed"
318 popd >/dev/null || die "Can't popd from ${S}/${x}" 640 popd >/dev/null || die
319 done 641 done
320} 642}
321 643
322# @ECLASS-VARIABLE: QCONFIG_ADD 644# @ECLASS-VARIABLE: QCONFIG_ADD
323# @DESCRIPTION: 645# @DESCRIPTION:
324# List options that need to be added to QT_CONFIG in qconfig.pri 646# List options that need to be added to QT_CONFIG in qconfig.pri
325QCONFIG_ADD="${QCONFIG_ADD:-}" 647: ${QCONFIG_ADD:=}
326 648
327# @ECLASS-VARIABLE: QCONFIG_REMOVE 649# @ECLASS-VARIABLE: QCONFIG_REMOVE
328# @DESCRIPTION: 650# @DESCRIPTION:
329# List options that need to be removed from QT_CONFIG in qconfig.pri 651# List options that need to be removed from QT_CONFIG in qconfig.pri
330QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 652: ${QCONFIG_REMOVE:=}
331 653
332# @ECLASS-VARIABLE: QCONFIG_DEFINE 654# @ECLASS-VARIABLE: QCONFIG_DEFINE
333# @DESCRIPTION: 655# @DESCRIPTION:
334# List variables that should be defined at the top of QtCore/qconfig.h 656# List variables that should be defined at the top of QtCore/qconfig.h
335QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 657: ${QCONFIG_DEFINE:=}
336 658
337# @FUNCTION: install_qconfigs 659# @FUNCTION: install_qconfigs
660# @INTERNAL
661# @DESCRIPTION:
338# @DESCRIPTION: Install gentoo-specific mkspecs configurations 662# Install gentoo-specific mkspecs configurations.
339install_qconfigs() { 663install_qconfigs() {
340 local x 664 local x
341 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 665 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
342 for x in QCONFIG_ADD QCONFIG_REMOVE; do 666 for x in QCONFIG_ADD QCONFIG_REMOVE; do
343 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 667 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
344 done 668 done
345 insinto ${QTDATADIR}/mkspecs/gentoo 669 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
346 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 670 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
347 fi 671 fi
348 672
349 if [[ -n ${QCONFIG_DEFINE} ]]; then 673 if [[ -n ${QCONFIG_DEFINE} ]]; then
350 for x in ${QCONFIG_DEFINE}; do 674 for x in ${QCONFIG_DEFINE}; do
351 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 675 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
352 done 676 done
353 insinto ${QTHEADERDIR}/Gentoo 677 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
354 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 678 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
355 fi 679 fi
356} 680}
357 681
358# @FUNCTION: generate_qconfigs 682# @FUNCTION: generate_qconfigs
359# @DESCRIPTION: Generates gentoo-specific configurations 683# @INTERNAL
684# @DESCRIPTION:
685# Generates gentoo-specific qconfig.{h,pri}.
360generate_qconfigs() { 686generate_qconfigs() {
361 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 687 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
362 local x qconfig_add qconfig_remove qconfig_new 688 local x qconfig_add qconfig_remove qconfig_new
363 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 689 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
364 [[ -f ${x} ]] || continue 690 [[ -f ${x} ]] || continue
365 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 691 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
366 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 692 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
367 done 693 done
368 694
369 # these error checks do not use die because dying in pkg_post{inst,rm} 695 # these error checks do not use die because dying in pkg_post{inst,rm}
370 # just makes things worse. 696 # just makes things worse.
371 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 697 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
378 704
379 # generate list of QT_CONFIG entries from the existing list 705 # generate list of QT_CONFIG entries from the existing list
380 # including qconfig_add and excluding qconfig_remove 706 # including qconfig_add and excluding qconfig_remove
381 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 707 for x in $(sed -n 's/^QT_CONFIG +=//p' \
382 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 708 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
383 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 709 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
384 done 710 done
385 711
386 # replace the existing QT_CONFIG list with qconfig_new 712 # replace the existing QT_CONFIG list with qconfig_new
387 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 713 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
388 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 714 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
412 fi 738 fi
413 fi 739 fi
414} 740}
415 741
416# @FUNCTION: qt4-build_pkg_postrm 742# @FUNCTION: qt4-build_pkg_postrm
743# @DESCRIPTION:
417# @DESCRIPTION: Generate configurations when the package is completely removed 744# Regenerate configuration when the package is completely removed.
418qt4-build_pkg_postrm() { 745qt4-build_pkg_postrm() {
419 generate_qconfigs 746 generate_qconfigs
420} 747}
421 748
422# @FUNCTION: qt4-build_pkg_postinst 749# @FUNCTION: qt4-build_pkg_postinst
750# @DESCRIPTION:
423# @DESCRIPTION: Generate configuration, plus throws a message about possible 751# Regenerate configuration, plus throw a message about possible
424# breakages and proposed solutions. 752# breakages and proposed solutions.
425qt4-build_pkg_postinst() { 753qt4-build_pkg_postinst() {
426 generate_qconfigs 754 generate_qconfigs
427 echo
428 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
429 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
430 ewarn "should recompile the packages providing these plugins. Also, make sure you"
431 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
432 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
433 ewarn
434 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
435 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
436 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
437 ewarn "configuration."
438 ewarn
439 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
440 echo
441} 755}
442 756
443# @FUNCTION: skip_qmake_build_patch 757# @FUNCTION: skip_qmake_build
758# @INTERNAL
444# @DESCRIPTION: 759# @DESCRIPTION:
445# Don't need to build qmake, as it's already installed from qt-core 760# Patches configure to skip qmake compilation, as it's already installed by qt-core.
446skip_qmake_build_patch() { 761skip_qmake_build() {
447 # Don't need to build qmake, as it's already installed from qt-core
448 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 762 sed -i -e "s:if true:if false:g" "${S}"/configure || die
449} 763}
450 764
451# @FUNCTION: skip_project_generation_patch 765# @FUNCTION: skip_project_generation
766# @INTERNAL
452# @DESCRIPTION: 767# @DESCRIPTION:
453# Exit the script early by throwing in an exit before all of the .pro files are scanned 768# Exit the script early by throwing in an exit before all of the .pro files are scanned.
454skip_project_generation_patch() { 769skip_project_generation() {
455 # Exit the script early by throwing in an exit before all of the .pro files are scanned
456 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 770 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
457 -i "${S}"/configure || die "Sed failed"
458} 771}
459 772
460# @FUNCTION: symlink_binaries_to_buildtree 773# @FUNCTION: symlink_binaries_to_buildtree
774# @INTERNAL
461# @DESCRIPTION: 775# @DESCRIPTION:
462# Symlink generated binaries to buildtree so they can be used during compilation 776# Symlinks generated binaries to buildtree, so they can be used during compilation time.
463# time
464symlink_binaries_to_buildtree() { 777symlink_binaries_to_buildtree() {
465 for bin in qmake moc uic rcc; do 778 for bin in qmake moc uic rcc; do
466 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 779 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
467 done 780 done
468} 781}
469 782
470# @FUNCTION: fix_library_files 783# @FUNCTION: fix_library_files
784# @INTERNAL
471# @DESCRIPTION: 785# @DESCRIPTION:
472# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 786# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
473# moves the *.pc-files into the pkgconfig directory 787# moves the *.pc files into the pkgconfig directory.
474fix_library_files() { 788fix_library_files() {
789 local libfile
475 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 790 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
476 if [[ -e ${libfile} ]]; then 791 if [[ -e ${libfile} ]]; then
477 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 792 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
478 fi 793 fi
479 done 794 done
480 795
481 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 796 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
482 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 797 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
483 if [[ -e ${libfile} ]]; then 798 if [[ -e ${libfile} ]]; then
484 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 799 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
485 800
486 # Move .pc files into the pkgconfig directory 801 # Move .pc files into the pkgconfig directory
487 dodir ${QTPCDIR} 802 dodir ${QTPCDIR#${EPREFIX}}
488 mv ${libfile} "${D}"/${QTPCDIR}/ \ 803 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
489 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
490 fi 804 fi
491 done 805 done
492 806
493 # Don't install an empty directory 807 # Don't install an empty directory
494 rmdir "${D}"/${QTLIBDIR}/pkgconfig 808 rmdir "${D}"/${QTLIBDIR}/pkgconfig
495} 809}
496 810
497# @FUNCTION: qt_use 811# @FUNCTION: qt_use
498# @USAGE: < flag > [ feature ] [ enableval ] 812# @USAGE: < flag > [ feature ] [ enableval ]
499# @DESCRIPTION: 813# @DESCRIPTION:
500# This will echo "${enableval}-${feature}" if <flag> is enabled, or 814# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
501# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 815# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
502# will be used for that. If [enableval] is not specified, it omits the 816# will be used for that. If [enableval] is not specified, it omits the
503# assignment-part 817# "-${enableval}" part.
504qt_use() { 818qt_use() {
505 local flag="${1}" 819 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
506 local feature="${1}"
507 local enableval=
508
509 [[ -n ${2} ]] && feature=${2}
510 [[ -n ${3} ]] && enableval="-${3}"
511
512 if use ${flag}; then
513 echo "${enableval}-${feature}"
514 else
515 echo "-no-${feature}"
516 fi
517}
518
519# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK
520# @DESCRIPTION:
521# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use
522# (eutils.eclass), line per line.
523#
524# Example:
525# @CODE
526# pkg_setup() {
527# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
528# ~x11-libs/qt-gui-${PV} qt3support"
529# qt4-build_check_use
530# }
531# @CODE
532
533# Run built_with_use on each flag and print appropriate error messages if any
534# flags are missing
535
536_qt_built_with_use() {
537 local missing opt pkg flag flags
538
539 if [[ ${1} = "--missing" ]]; then
540 missing="${1} ${2}" && shift 2
541 fi
542 if [[ ${1:0:1} = "-" ]]; then
543 opt=${1} && shift
544 fi
545
546 pkg=${1} && shift
547
548 for flag in "${@}"; do
549 flags="${flags} ${flag}"
550 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
551 flags="${flags}*"
552 else
553 [[ ${opt} = "-o" ]] && return 0
554 fi
555 done
556 if [[ "${flags# }" = "${@}" ]]; then
557 return 0
558 fi
559 if [[ ${opt} = "-o" ]]; then
560 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
561 else
562 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
563 fi
564 return 1
565}
566
567# @FUNCTION: qt4-build_check_use
568# @DESCRIPTION:
569# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
570# USE flags listed.
571#
572# If any of the required USE flags are missing, an eerror will be printed for
573# each package with missing USE flags.
574qt4-build_check_use() {
575 local line missing
576 while read line; do
577 [[ -z ${line} ]] && continue
578 if ! _qt_built_with_use ${line}; then
579 missing=true
580 fi
581 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
582 if [[ -n ${missing} ]]; then
583 echo
584 eerror "Flags marked with an * are missing."
585 die "Missing USE flags found"
586 fi
587} 820}
588 821
589# @FUNCTION: qt_mkspecs_dir 822# @FUNCTION: qt_mkspecs_dir
590# @RETURN: the specs-directory w/o path 823# @RETURN: the specs-directory w/o path
591# @DESCRIPTION: 824# @DESCRIPTION:
592# Allows us to define which mkspecs dir we want to use. 825# Allows us to define which mkspecs dir we want to use.
593qt_mkspecs_dir() { 826qt_mkspecs_dir() {
594 # Allows us to define which mkspecs dir we want to use.
595 local spec 827 local spec=
596 828
597 case ${CHOST} in 829 case "${CHOST}" in
598 *-freebsd*|*-dragonfly*) 830 *-freebsd*|*-dragonfly*)
599 spec="freebsd" ;; 831 spec=freebsd ;;
600 *-openbsd*) 832 *-openbsd*)
601 spec="openbsd" ;; 833 spec=openbsd ;;
602 *-netbsd*) 834 *-netbsd*)
603 spec="netbsd" ;; 835 spec=netbsd ;;
604 *-darwin*) 836 *-darwin*)
837 if use aqua; then
838 # mac with carbon/cocoa
839 spec=macx
840 else
841 # darwin/mac with x11
605 spec="darwin" ;; 842 spec=darwin
843 fi
844 ;;
845 *-solaris*)
846 spec=solaris ;;
606 *-linux-*|*-linux) 847 *-linux-*|*-linux)
607 spec="linux" ;; 848 spec=linux ;;
608 *) 849 *)
609 die "Unknown CHOST, no platform choosen." 850 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
610 esac 851 esac
611 852
612 CXX=$(tc-getCXX) 853 case "$(tc-getCXX)" in
613 if [[ ${CXX/g++/} != ${CXX} ]]; then 854 *g++*)
614 spec="${spec}-g++" 855 spec+=-g++ ;;
615 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 856 *icpc*)
616 spec="${spec}-icc" 857 spec+=-icc ;;
617 else 858 *)
618 die "Unknown compiler ${CXX}." 859 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
860 esac
861
862 # Add -64 for 64bit profiles
863 if use x64-freebsd ||
864 use amd64-linux ||
865 use x64-macos ||
866 use x64-solaris ||
867 use sparc64-solaris
868 then
869 spec+=-64
619 fi 870 fi
620 871
621 echo "${spec}" 872 echo "${spec}"
622} 873}
623 874
624case ${EAPI:-0} in 875# @FUNCTION: qt_nolibx11
625 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 876# @INTERNAL
877# @DESCRIPTION:
878# Ignore X11 tests for packages that don't need X libraries installed.
879qt_nolibx11() {
880 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
881 die "x11 check sed failed"
882}
883
626 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 884EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
627esac

Legend:
Removed from v.1.40  
changed lines
  Added in v.1.139

  ViewVC Help
Powered by ViewVC 1.1.20